`timescale 1ns / 1ps
`default_nettype none

module gyak1_2(
   //8 bites bemeneti port, a neve sw.
   input  wire [7:0] sw,
   //8 bites kimeneti port, a neve ld.
   output wire [7:0] ld
);

//Bels jelek megadsa: hasonl a portokhoz, de nincs irny.
wire [3:0] a = sw[3:0];
wire [3:0] b = sw[7:4];

//tvitel bit lnc.
wire [4:0] carry;

assign carry[0] = 1'b0;

//A generate blokkal 4 fadd pldnyt hozunk ltre.
genvar i;

generate
   for (i = 0; i < 4; i = i + 1)
   begin: fadd_loop
      fadd add(
         //Az egyik sszeadand bit.
         .a(a[i]),
         //A msik sszeadand bit.
         .b(b[i]),
         //A bejv tvitel bit.
         .ci(carry[i]),
         //A kimen ssze bit.
         .s(ld[i]),
         //A kimen tvitel bit.
         .co(carry[i+1])
      );
   end
endgenerate

//A fels 4 LED meghajtsa.
assign ld[4]   = carry[4];
assign ld[7:5] = 3'b000;

endmodule

`default_nettype wire
